#include <stdio.h>
#include <stdlib.h>

#define dword unsigned long
#define word unsigned short

#define ASCALE 0xB60B60	/* 0xfffffff / 360 32*7*17*3133 */

#pragma pack(1)
/* 26 byte record  */
typedef struct NYPRecord_t {
	dword  ILon;
	dword  ILat;
	dword  IAng;
	dword  Unknown3;
	dword  recTime;
	dword  Unknown5;
	word   Unknown6;
} NYPRecord;
#pragma pack()

NYPRecord  record;

unsigned char header[] = {
	0x00,0x01,0x00,0x00,0x00,0x01,0x00,0x00,
	0x00,0x0C,0x93,0xA1,0x96,0xEC,0x81,0x60,
	0x92,0x6B,0x8D,0x87,0x8D,0xE2,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x07,0x00,0x00,0x00,0x24,0x00,0x00,
	0x26,0xA4,0x34,0xD4,0x56,0x1E,0x01,0x62,
	0xF5,0x71,0x01,0x19,0x53,0x1D,0x07,0x62,
	0xE3,0x21,0x47,0x19,0x56,0x31,0x9C,0x00,
	0x00,0x2E,0xBB,0x00,0x00,0x00,0x20,0x82,
	0x62,0x82,0x63,0x82,0x6C,0x82,0x60,0x82,
	0x6F,0x81,0x40,0x91,0x53,0x8D,0x91,0x94,
	0xC5,0x82,0x72,0x82,0x51,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

FILE *OUTFile;
dword n,lat,lon;
long pos;

dword dswab(dword big);

void main(int argc,char *argv[])
{
	if ((OUTFile = fopen(argv[1],"wb")) == NULL) {
		printf("\n*Error - can't open data file -- '%s' !\n",argv[1]);
		exit(1);
	}
	fwrite(header,sizeof(char),sizeof(header),OUTFile);
	n = 0;
	pos = ftell(OUTFile);
	fwrite(&n,sizeof(n),1,OUTFile);
	for (lat = 30*ASCALE;lat < 46*ASCALE ; lat += ASCALE/2) {
		for (lon = 130*ASCALE;lon < 145*ASCALE ; lon += ASCALE/2) {
			++n;
			record.ILat = dswab(lat);
			record.ILon = dswab(lon);
			record.IAng = dswab((n%360) * ASCALE);
			record.Unknown3 = 0;
			record.recTime = 0;
			record.Unknown5 = 0;
			record.Unknown6 = 0;
			fwrite(&record,sizeof(record),1,OUTFile);
		}
	}
	fseek(OUTFile,pos,SEEK_SET);
	n = dswab(n);
	fwrite(&n,sizeof(n),1,OUTFile);
}

dword dswab(dword big)
{
	dword little;
	char *p,*q;

	p =((char *)&big) +3;
	q =(char *)&little;

	*q++ = *p--;
	*q++ = *p--;
	*q++ = *p--;
	*q = *p;
	return little;
}
