/* txt2mtk.c V0.11
Convert
 Waypoint+ text format TRACK data(.txt)
to
 MapFanII TRACK data(.trk)
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

double lat,lng;

double base256(double d,int typ);

char *typstr[]= {
    "DEG","DM","DMS"
};

char lbuf[96];

void main()
{
    char *p;
    int typ;
    int point;

    while((p=gets(lbuf))!=NULL)
        if (strncmp(p,"Datum",5) == 0)
            break;

    if (p == NULL) {
        printf("*Error - Unexpected EOF.\n");
        exit(1);
    }
    if (strncmp(p+6,"Tokyo",5)!=0 ) {
        printf("*Error - illegal Datum(Tokyo expected).\n");
        exit(1);
    }
    printf("16\n");
    while((p=gets(lbuf))!=NULL)
        if (strncmp(p,"TP",2) == 0)
            break;
    if (p == NULL) {
        printf("*Error - Unexpected EOF.\n");
        exit(1);
    }
    for (typ = 2; typ >= 0; --typ)
        if (strncmp(p+3,typstr[typ],typ+1) == 0)
            break;
    if (typ < 0) {
        printf("*Error - illegal format(D or DM or DMS expected).\n");
        exit(1);
    }
    point = 0;
    do {
        if (point >=750) {
            fprintf(stderr,"over 750 points, data is trancated.\n");
            break;
        }
        if (strncmp(p,"TP",2) == 0) {
            if (strncmp(p+3,typstr[typ],typ+1) != 0) {
                printf("*Error - illegal format(%s expected).\n",typstr[typ]);
                exit(1);
            }
            p += typ;   /* add offset.(typ == offset) */
            lat = base256(atof(p+6),typ);
            lng = base256(atof(p+20),typ);
            printf("%8.0f,%9.0f\n",lat,lng);
            ++point;
        }
    } while((p=gets(lbuf))!=NULL) ;
}
double base256(double d,int typ)
{
    double x;

    /* convert to DEG */
    switch(typ){
        case 0:
            break;
        case 1:/*DM*/
            d = floor(d)+(d-floor(d))*5.0/3.0;
            break;
        case 2:/*DMS*/
            x = (d-floor(d))*100.0;
            d = floor(d) + floor(x)/60.0 + (x-floor(x))/36.0;
            break;
        default:
            break;
    }
    return d*256*3600;
}

